//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Evenement: JSONDecodable, JSONEncodable, PrettyPrintable {

    public enum TypeEvenement: String {
        case actsoupcon = "ACT_SOUPCON"
        case actdangeravere = "ACT_DANGER_AVERE"
        case actconfirme = "ACT_CONFIRME"
        case actannule = "ACT_ANNULE"
        case obsdanger = "OBS_DANGER"
        case obscallok = "OBS_CALLOK"
        case obsras = "OBS_RAS"
        case obspolice = "OBS_POLICE"
        case obsokmerci = "OBS_OKMERCI"
        case obsverif = "OBS_VERIF"

        public static let cases: [TypeEvenement] = [
          .actsoupcon,
          .actdangeravere,
          .actconfirme,
          .actannule,
          .obsdanger,
          .obscallok,
          .obsras,
          .obspolice,
          .obsokmerci,
          .obsverif,
        ]
    }

    public var dateCreated: Date?

    public var nomFoyerEmetteur: String?

    public var typeEvenement: TypeEvenement?

    public init(dateCreated: Date? = nil, nomFoyerEmetteur: String? = nil, typeEvenement: TypeEvenement? = nil) {
        self.dateCreated = dateCreated
        self.nomFoyerEmetteur = nomFoyerEmetteur
        self.typeEvenement = typeEvenement
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        dateCreated = jsonDictionary.json(atKeyPath: "dateCreated")
        nomFoyerEmetteur = jsonDictionary.json(atKeyPath: "nomFoyerEmetteur")
        typeEvenement = jsonDictionary.json(atKeyPath: "typeEvenement")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let dateCreated = dateCreated?.encode() {
            dictionary["dateCreated"] = dateCreated
        }
        if let nomFoyerEmetteur = nomFoyerEmetteur {
            dictionary["nomFoyerEmetteur"] = nomFoyerEmetteur
        }
        if let typeEvenement = typeEvenement?.encode() {
            dictionary["typeEvenement"] = typeEvenement
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
